// Code generated by girgen. DO NOT EDIT.

package gio

import (
	"runtime"
	"unsafe"

	"github.com/diamondburned/gotk4/pkg/core/gerror"
	externglib "github.com/diamondburned/gotk4/pkg/core/glib"
)

// #include <stdlib.h>
// #include <gio/gio.h>
// #include <glib-object.h>
import "C"

// glib.Type values for gcharsetconverter.go.
var GTypeCharsetConverter = externglib.Type(C.g_charset_converter_get_type())

func init() {
	externglib.RegisterGValueMarshalers([]externglib.TypeMarshaler{
		{T: GTypeCharsetConverter, F: marshalCharsetConverter},
	})
}

// CharsetConverterOverrider contains methods that are overridable.
type CharsetConverterOverrider interface {
}

// CharsetConverter is an implementation of #GConverter based on GIConv.
type CharsetConverter struct {
	_ [0]func() // equal guard
	*externglib.Object

	Converter
	Initable
}

var (
	_ externglib.Objector = (*CharsetConverter)(nil)
)

func classInitCharsetConverterer(gclassPtr, data C.gpointer) {
	C.g_type_class_add_private(gclassPtr, C.gsize(unsafe.Sizeof(uintptr(0))))

	goffset := C.g_type_class_get_instance_private_offset(gclassPtr)
	*(*C.gpointer)(unsafe.Add(unsafe.Pointer(gclassPtr), goffset)) = data

}

func wrapCharsetConverter(obj *externglib.Object) *CharsetConverter {
	return &CharsetConverter{
		Object: obj,
		Converter: Converter{
			Object: obj,
		},
		Initable: Initable{
			Object: obj,
		},
	}
}

func marshalCharsetConverter(p uintptr) (interface{}, error) {
	return wrapCharsetConverter(externglib.ValueFromNative(unsafe.Pointer(p)).Object()), nil
}

// NewCharsetConverter creates a new Converter.
//
// The function takes the following parameters:
//
//    - toCharset: destination charset.
//    - fromCharset: source charset.
//
// The function returns the following values:
//
//    - charsetConverter: new Converter or NULL on error.
//
func NewCharsetConverter(toCharset, fromCharset string) (*CharsetConverter, error) {
	var _arg1 *C.gchar             // out
	var _arg2 *C.gchar             // out
	var _cret *C.GCharsetConverter // in
	var _cerr *C.GError            // in

	_arg1 = (*C.gchar)(unsafe.Pointer(C.CString(toCharset)))
	defer C.free(unsafe.Pointer(_arg1))
	_arg2 = (*C.gchar)(unsafe.Pointer(C.CString(fromCharset)))
	defer C.free(unsafe.Pointer(_arg2))

	_cret = C.g_charset_converter_new(_arg1, _arg2, &_cerr)
	runtime.KeepAlive(toCharset)
	runtime.KeepAlive(fromCharset)

	var _charsetConverter *CharsetConverter // out
	var _goerr error                        // out

	_charsetConverter = wrapCharsetConverter(externglib.AssumeOwnership(unsafe.Pointer(_cret)))
	if _cerr != nil {
		_goerr = gerror.Take(unsafe.Pointer(_cerr))
	}

	return _charsetConverter, _goerr
}

// NumFallbacks gets the number of fallbacks that converter has applied so far.
//
// The function returns the following values:
//
//    - guint: number of fallbacks that converter has applied.
//
func (converter *CharsetConverter) NumFallbacks() uint {
	var _arg0 *C.GCharsetConverter // out
	var _cret C.guint              // in

	_arg0 = (*C.GCharsetConverter)(unsafe.Pointer(externglib.InternObject(converter).Native()))

	_cret = C.g_charset_converter_get_num_fallbacks(_arg0)
	runtime.KeepAlive(converter)

	var _guint uint // out

	_guint = uint(_cret)

	return _guint
}

// UseFallback gets the Converter:use-fallback property.
//
// The function returns the following values:
//
//    - ok: TRUE if fallbacks are used by converter.
//
func (converter *CharsetConverter) UseFallback() bool {
	var _arg0 *C.GCharsetConverter // out
	var _cret C.gboolean           // in

	_arg0 = (*C.GCharsetConverter)(unsafe.Pointer(externglib.InternObject(converter).Native()))

	_cret = C.g_charset_converter_get_use_fallback(_arg0)
	runtime.KeepAlive(converter)

	var _ok bool // out

	if _cret != 0 {
		_ok = true
	}

	return _ok
}

// SetUseFallback sets the Converter:use-fallback property.
//
// The function takes the following parameters:
//
//    - useFallback: TRUE to use fallbacks.
//
func (converter *CharsetConverter) SetUseFallback(useFallback bool) {
	var _arg0 *C.GCharsetConverter // out
	var _arg1 C.gboolean           // out

	_arg0 = (*C.GCharsetConverter)(unsafe.Pointer(externglib.InternObject(converter).Native()))
	if useFallback {
		_arg1 = C.TRUE
	}

	C.g_charset_converter_set_use_fallback(_arg0, _arg1)
	runtime.KeepAlive(converter)
	runtime.KeepAlive(useFallback)
}
