// Code generated by girgen. DO NOT EDIT.

package pango

import (
	"fmt"
	"runtime"
	"unsafe"

	externglib "github.com/diamondburned/gotk4/pkg/core/glib"
)

// #include <stdlib.h>
// #include <glib-object.h>
// #include <pango/pango.h>
import "C"

// glib.Type values for pango-bidi-type.go.
var GTypeBidiType = externglib.Type(C.pango_bidi_type_get_type())

func init() {
	externglib.RegisterGValueMarshalers([]externglib.TypeMarshaler{
		{T: GTypeBidiType, F: marshalBidiType},
	})
}

// BidiType: PangoBidiType represents the bidirectional character type of a
// Unicode character as specified by the <ulink
// url="http://www.unicode.org/reports/tr9/">Unicode bidirectional
// algorithm</ulink>.
//
// Deprecated: Use fribidi for this information.
type BidiType C.gint

const (
	// BidiTypeL: left-to-Right.
	BidiTypeL BidiType = iota
	// BidiTypeLre: left-to-Right Embedding.
	BidiTypeLre
	// BidiTypeLro: left-to-Right Override.
	BidiTypeLro
	// BidiTypeR: right-to-Left.
	BidiTypeR
	// BidiTypeAl: right-to-Left Arabic.
	BidiTypeAl
	// BidiTypeRLE: right-to-Left Embedding.
	BidiTypeRLE
	// BidiTypeRlo: right-to-Left Override.
	BidiTypeRlo
	// BidiTypePDF: pop Directional Format.
	BidiTypePDF
	// BidiTypeEn: european Number.
	BidiTypeEn
	// BidiTypeES: european Number Separator.
	BidiTypeES
	// BidiTypeEt: european Number Terminator.
	BidiTypeEt
	// BidiTypeAn: arabic Number.
	BidiTypeAn
	// BidiTypeCs: common Number Separator.
	BidiTypeCs
	// BidiTypeNsm: nonspacing Mark.
	BidiTypeNsm
	// BidiTypeBn: boundary Neutral.
	BidiTypeBn
	// BidiTypeB: paragraph Separator.
	BidiTypeB
	// BidiTypeS: segment Separator.
	BidiTypeS
	// BidiTypeWs: whitespace.
	BidiTypeWs
	// BidiTypeOn: other Neutrals.
	BidiTypeOn
)

func marshalBidiType(p uintptr) (interface{}, error) {
	return BidiType(externglib.ValueFromNative(unsafe.Pointer(p)).Enum()), nil
}

// String returns the name in string for BidiType.
func (b BidiType) String() string {
	switch b {
	case BidiTypeL:
		return "L"
	case BidiTypeLre:
		return "Lre"
	case BidiTypeLro:
		return "Lro"
	case BidiTypeR:
		return "R"
	case BidiTypeAl:
		return "Al"
	case BidiTypeRLE:
		return "RLE"
	case BidiTypeRlo:
		return "Rlo"
	case BidiTypePDF:
		return "PDF"
	case BidiTypeEn:
		return "En"
	case BidiTypeES:
		return "ES"
	case BidiTypeEt:
		return "Et"
	case BidiTypeAn:
		return "An"
	case BidiTypeCs:
		return "Cs"
	case BidiTypeNsm:
		return "Nsm"
	case BidiTypeBn:
		return "Bn"
	case BidiTypeB:
		return "B"
	case BidiTypeS:
		return "S"
	case BidiTypeWs:
		return "Ws"
	case BidiTypeOn:
		return "On"
	default:
		return fmt.Sprintf("BidiType(%d)", b)
	}
}

// BidiTypeForUnichar determines the bidirectional type of a character.
//
// The bidirectional type is specified in the Unicode Character Database.
//
// A simplified version of this function is available as unichar_direction.
//
// The function takes the following parameters:
//
//    - ch: unicode character.
//
// The function returns the following values:
//
//    - bidiType: bidirectional character type, as used in the Unicode
//      bidirectional algorithm.
//
func BidiTypeForUnichar(ch uint32) BidiType {
	var _arg1 C.gunichar      // out
	var _cret C.PangoBidiType // in

	_arg1 = C.gunichar(ch)

	_cret = C.pango_bidi_type_for_unichar(_arg1)
	runtime.KeepAlive(ch)

	var _bidiType BidiType // out

	_bidiType = BidiType(_cret)

	return _bidiType
}

// FindBaseDir searches a string the first character that has a strong
// direction, according to the Unicode bidirectional algorithm.
//
// The function takes the following parameters:
//
//    - text to process. Must be valid UTF-8.
//    - length of text in bytes (may be -1 if text is nul-terminated).
//
// The function returns the following values:
//
//    - direction corresponding to the first strong character. If no such
//      character is found, then PANGO_DIRECTION_NEUTRAL is returned.
//
func FindBaseDir(text string, length int) Direction {
	var _arg1 *C.gchar         // out
	var _arg2 C.gint           // out
	var _cret C.PangoDirection // in

	_arg1 = (*C.gchar)(unsafe.Pointer(C.CString(text)))
	defer C.free(unsafe.Pointer(_arg1))
	_arg2 = C.gint(length)

	_cret = C.pango_find_base_dir(_arg1, _arg2)
	runtime.KeepAlive(text)
	runtime.KeepAlive(length)

	var _direction Direction // out

	_direction = Direction(_cret)

	return _direction
}

// GetMirrorChar returns the mirrored character of a Unicode character.
//
// Mirror characters are determined by the Unicode mirrored property.
//
// Use g_unichar_get_mirror_char() instead; the docs for that function provide
// full details.
//
// The function takes the following parameters:
//
//    - ch: unicode character.
//    - mirroredCh: location to store the mirrored character.
//
// The function returns the following values:
//
//    - ok: TRUE if ch has a mirrored character and mirrored_ch is filled in,
//      FALSE otherwise.
//
func GetMirrorChar(ch uint32, mirroredCh *uint32) bool {
	var _arg1 C.gunichar  // out
	var _arg2 *C.gunichar // out
	var _cret C.gboolean  // in

	_arg1 = C.gunichar(ch)
	_arg2 = (*C.gunichar)(unsafe.Pointer(mirroredCh))

	_cret = C.pango_get_mirror_char(_arg1, _arg2)
	runtime.KeepAlive(ch)
	runtime.KeepAlive(mirroredCh)

	var _ok bool // out

	if _cret != 0 {
		_ok = true
	}

	return _ok
}

// UnicharDirection determines the inherent direction of a character.
//
// The inherent direction is either PANGO_DIRECTION_LTR, PANGO_DIRECTION_RTL, or
// PANGO_DIRECTION_NEUTRAL.
//
// This function is useful to categorize characters into left-to-right letters,
// right-to-left letters, and everything else. If full Unicode bidirectional
// type of a character is needed, pango.BidiType.ForUnichar can be used instead.
//
// The function takes the following parameters:
//
//    - ch: unicode character.
//
// The function returns the following values:
//
//    - direction of the character.
//
func UnicharDirection(ch uint32) Direction {
	var _arg1 C.gunichar       // out
	var _cret C.PangoDirection // in

	_arg1 = C.gunichar(ch)

	_cret = C.pango_unichar_direction(_arg1)
	runtime.KeepAlive(ch)

	var _direction Direction // out

	_direction = Direction(_cret)

	return _direction
}
